; DEFINICE KONSTANT:
symbol TRIM = 10
symbol LEFT = 90 - TRIM
symbol CENTER = 150 - TRIM
symbol RIGHT = 210 - TRIM
symbol SERVO_DELAY = 200

symbol HAND_OPEN = 160
symbol HAND_HOLD = 100

symbol SERVO = 3
symbol CLK = 2
symbol STROBE = 1
symbol LED = 0

; +--------------------------------------------------------+
; | PRIPRAVA VYSTUPNICH PORTU                              |
; +--------------------------------------------------------+
; | Poradi je zde z mnemotechnickych duvodu zprehazeno dle |
; | skutecneho poredi pinu na desce Hobbyrobot-Picaxe      |
; +--------------------------------------------------------+
	low SERVO	; 3 (bily) Vystup pulsu na servo
	high CLK	; 2 (sedy) CLK pro A/D prevodnik
	low STROBE	; 1 (hnedy) STROBE pro A/D prevodnik 
	low LED	; 0 (bily) Vystup na signalizacni LED
	low 7  ;  (zeleny) H-mustek pro pravy motor
	low 6	;  (zeleny) H-mustek pro pravy motor
	low 5	; (cerveny) H-mustek pro levy motor 
	low 4	; (cerveny) H-mustek pro levy motor



b0 = CENTER
b1 = HAND_OPEN



; +--------------------------------------------------------+
; | HLAVNI SMYCKA PROGRAMU                                 |
; +--------------------------------------------------------+

mainCycle:

	'ROZSAH <75-225>

	if pin2 = 1 then
		;b0 = CENTER
		servo 3,CENTER
		pause SERVO_DELAY
	else
		;b0 = LEFT
		servo 3,LEFT
		pause SERVO_DELAY
		servo 3,CENTER
		pause SERVO_DELAY
		servo 3,RIGHT
		pause SERVO_DELAY
		servo 3,CENTER
		pause SERVO_DELAY
	endif



	if pin6 = 1 then
		gosub motorLeft_stop
	else
		gosub motorLeft_ahead
	endif



	if pin7 = 1 then
		gosub motorRight_stop
	else
		gosub motorRight_ahead
	endif



	if pin1 = 1 then
		gosub LED_off
	else
		gosub LED_on
	endif



	gosub getRange

	goto mainCycle



; +--------------------------------------------------------+
; | OVLADANI LEVEHO MOTORU                                 |
; +--------------------------------------------------------+

; LEVY MOTOR STOP:
motorLeft_stop:
	low 4
	low 5
	return

; LEVY MOTOR VPRED:
motorLeft_ahead:
	low 4
	high 5
	return

; LEVY MOTOR VZAD:
motorLeft_back:
	high 4
	low 5
	return



; +--------------------------------------------------------+
; | OVLADANI PRAVEHO MOTORU                                |
; +--------------------------------------------------------+

; PRAVY MOTOR STOP:
motorRight_stop:
	low 6
	low 7
	return

; PRAVY MOTOR VPRED:
motorRight_ahead:
	high 6
	low 7
	return

; PRAVY MOTOR VZAD:
motorRight_back:
	low 6
	high 7
	return



; +--------------------------------------------------------+
; | SIGNALISACNI LED                                       |
; +--------------------------------------------------------+

LED_off:
	low 0
	return

LED_on:
	high 0
	return



; +--------------------------------------------------------+
; | INFRADALKOMER                                          |
; +--------------------------------------------------------+
; | Nejdrive se shodi STROBE. Pote se nahazuji hodinove    |
; | pulzy CLK a vzdy po jejich shozeni se cte stav vstupu  |
; | z A/D prevodniku. Celkem se takto cte bitu.            |
; +--------------------------------------------------------+

getRange:
	low STROBE		; Shozeni STROBE
	pause 10		; Nezbytna casova prodleva

	b0 = 0

	for i = 0 to 7 do	
		b0 = b0 * 2	; Posun bitu doleva
		high CLK	; Nahozeni CLK
		pause 10	; Nezbytna casova prodleva
		if pin1 = 1 then
			b0 = b0 + 1
 		endif
		low CLK	; Shozeni CLK
		pause 10	; Nezbytna casova prodleva

	endfor

	high STROBE		; Nahozeni STROBE
	pause 10		; Nezbytna casova prodleva

	return



myServo:
	if pin6 = 1 then
		;b1 = HAND_OPEN
		gosub handOpen
	else
		;b1 = HAND_HOLD
		gosub handHold
	endif
	return


handOpen:
	high 2
	pause 3
	low 2
	pause 17
	return


handHold:
	high 2
	pause 2
	low 2
	pause 18
	return


	if pin2 = 0 then
		servo 3,75
		pause 15
	else
		servo 3,225
		pause 15
	endif

	if pin6 = 0 then
		servo 3,150
		pause 15
	endif

	goto mainCycle



	if pin1 = 0 then
		low 4
		pause 100
		high 4
		pause 100
	else
		high 4
	endif

	if pin0 = 0 then
		low 5
		pause 100
		high 5
		pause 100
	else
		high 5
	endif
	
	if pin7 = 0 then
		low 6
		pause 100
		high 6
		pause 100
	else
		high 6

	endif
	


	goto mainCycle




