; DEFINICE KONSTANT:
symbol TRIM = 10
symbol LEFT = 90 - TRIM
symbol CENTER = 150 - TRIM
symbol RIGHT = 210 - TRIM
symbol SERVO_DELAY = 200

symbol HAND_OPEN = 160
symbol HAND_HOLD = 100

symbol SERV = 3
symbol CLK = 2
symbol STROBE = 1
symbol LED = 0

symbol DISTANCE_10_CM = 128
symbol DISTANCE_20_CM = 82
symbol DISTANCE_30_CM = 64



; +--------------------------------------------------------+
; | PRIPRAVA VYSTUPNICH PORTU                              |
; +--------------------------------------------------------+
; | Poradi je zde z mnemotechnickych duvodu zprehazeno dle |
; | skutecneho poredi pinu na desce Hobbyrobot-Picaxe      |
; +--------------------------------------------------------+
	low SERV	; 3 (bily) Vystup pulsu na servo
	low CLK	; 2 (sedy) CLK pro A/D prevodnik
	high STROBE	; 1 (hnedy) STROBE pro A/D prevodnik 
	low LED	; 0 (bily) Vystup na signalizacni LED
	low 7  ;  (zeleny) H-mustek pro pravy motor
	low 6	;  (zeleny) H-mustek pro pravy motor
	low 5	; (cerveny) H-mustek pro levy motor 
	low 4	; (cerveny) H-mustek pro levy motor



b0 = CENTER
b1 = HAND_OPEN



; +--------------------------------------------------------+
; | HLAVNI SMYCKA PROGRAMU                                 |
; +--------------------------------------------------------+

mainCycle:

	'ROZSAH <75-225>

	if pin2 = 1 then
		;b0 = CENTER
		servo 3,CENTER
		pause SERVO_DELAY
	else
		;b0 = LEFT
		servo 3,LEFT
		pause SERVO_DELAY
		servo 3,CENTER
		pause SERVO_DELAY
		servo 3,RIGHT
		pause SERVO_DELAY
		servo 3,CENTER
		pause SERVO_DELAY
	endif



;	if pin6 = 1 then
;		gosub motorLeft_stop
;	else
;		gosub motorLeft_ahead
;	endif



;	if pin7 = 1 then
;		gosub motorRight_stop
;	else
;		gosub motorRight_ahead
;	endif



	gosub checkDistance	; Vzdalenost se ulozi do  promenne b2
	gosub decide



	;gosub getRange

	goto mainCycle



; +--------------------------------------------------------+
; | DECIDE                                                 |
; +--------------------------------------------------------+

decide:
	if b2 > 30 then
		gosub goAhead
		goto endTest
	endif

	if b2 > 20 then
		gosub goLeft
		goto endTest
	endif

	if b2 > 10 then
		gosub turnRight
		goto endTest
	endif

	gosub goBack

endTest:
	return



; +--------------------------------------------------------+
; | VPRED                                                  |
; +--------------------------------------------------------+
goAhead:
	gosub motorLeft_ahead
	gosub motorRight_ahead
	return



; +--------------------------------------------------------+
; | VZAD                                                  |
; +--------------------------------------------------------+
goBack:
	gosub motorLeft_back
	gosub motorRight_back
	return



; +--------------------------------------------------------+
; | VLEVO                                                  |
; +--------------------------------------------------------+
goLeft:
	gosub motorLeft_stop
	gosub motorRight_ahead
	return



; +--------------------------------------------------------+
; | VPRAVO                                                 |
; +--------------------------------------------------------+
turnRight:
	gosub motorLeft_ahead
	gosub motorRight_back
	return



; +--------------------------------------------------------+
; | OVLADANI LEVEHO MOTORU                                 |
; +--------------------------------------------------------+

; LEVY MOTOR STOP:
motorLeft_stop:
	low 4
	low 5
	return

; LEVY MOTOR VPRED:
motorLeft_ahead:
	low 4
	high 5
	return

; LEVY MOTOR VZAD:
motorLeft_back:
	high 4
	low 5
	return



; +--------------------------------------------------------+
; | OVLADANI PRAVEHO MOTORU                                |
; +--------------------------------------------------------+

; PRAVY MOTOR STOP:
motorRight_stop:
	low 6
	low 7
	return

; PRAVY MOTOR VPRED:
motorRight_ahead:
	high 6
	low 7
	return

; PRAVY MOTOR VZAD:
motorRight_back:
	low 6
	high 7
	return



; +--------------------------------------------------------+
; | SIGNALISACNI LED                                       |
; +--------------------------------------------------------+

;LED_off:
;	low 0
;	return

;LED_on:
;	high 0
;	return



; +--------------------------------------------------------+
; | INFRADALKOMER                                          |
; +--------------------------------------------------------+

checkDistance:
	readadc 0, b1

	if b1 < 64 then		; > 27 cm
		b2 = 40
		low LED
	else
	if b1 < 82 then		; > 27 cm
		b2 = 30
		low LED
	else
	if b1 < 128 then		; 10-27 cm 
		b2 = 20
		low LED
	else
		b2 = 10	
		high LED		; 0-10 cm
	endif
	endif
	endif

	return

