; +--------------------------------------------------------+
; | DEFINICE KONSTANT                                      |
; +--------------------------------------------------------+

; SERVO:
; ( Poloha serva muze byt v rozsahu <75-225> )
symbol TRIM = 10
symbol NIL = 0
symbol LEFT = 90 - TRIM
symbol CENTER = 150 - TRIM
symbol RIGHT = 210 - TRIM
symbol SERVO_DELAY = 500 ;200

; CHAPADLO:
symbol HAND_OPEN = 160
symbol HAND_HOLD = 100

; POMOCNE NAZVY PRO A/D PREVODNIK:
symbol SERV = 3
symbol LED_0 = 0
symbol LED_1 = 1
symbol LED_2 = 2

; POMOCNE NNAZVY PRO VZDALENOSTI:
symbol DISTANCE_10_CM = 128
symbol DISTANCE_20_CM = 82
symbol DISTANCE_30_CM = 64



; +--------------------------------------------------------+
; | VYUZITI PROMENNYCH b0..b13                             |                                      |
; +--------------------------------------------------------+
; b0	rezervovano
; b1	vzdalenost z infradalkomeru (pomocna promenna)
; b2	vzdalenost prekazky (diskretni hodnoty 0, 1, 2, 3)
; b3	aktulni smer dalkomeru, pripadne smer prekazky (diskretni hodnoty LEFT, CENTER, RIGHT)
; b4	prioritni smer, pripadne smer nejblizsi prekazky



; +--------------------------------------------------------+
; | PRIPRAVA VYSTUPNICH PORTU                              |
; +--------------------------------------------------------+
; | Poradi je zde z mnemotechnickych duvodu zprehazeno dle |
; | skutecneho poredi pinu na desce Hobbyrobot-Picaxe      |
; +--------------------------------------------------------+
	low SERV	; 3 (bily) Vystup pulsu na servo
	low LED_0	; 2 (sedy) CLK pro A/D prevodnik
	low LED_1	; 1 (hnedy) STROBE pro A/D prevodnik 
	low LED_2	; 0 (bily) Vystup na signalizacni LED
	low 7  ;  (zeleny) H-mustek pro pravy motor
	low 6	;  (zeleny) H-mustek pro pravy motor
	low 5	; (cerveny) H-mustek pro levy motor 
	low 4	; (cerveny) H-mustek pro levy motor



; +--------------------------------------------------------+
; | HLAVNI SMYCKA PROGRAMU                                 |
; +--------------------------------------------------------+
; | Cil: Pruzkum terenu. Hledat prekazky, ale nenarazet    |
; | do nich                                                |
; | Strategie:                                             |
; | Jede vpred,                                            |
; +--------------------------------------------------------+

mainCycle:


	if b2 > 2 then
 
	; Dalkomer kouka dopredu
		servo SERV,CENTER
		pause SERVO_DELAY
		b4 = CENTER
	endif

	; Dalkomer prozkoumava okoli:
	;else
	if b2 < 3 then

		; POKUD JE PREKAZKA NEJBLIZE, DALKOMER KOUKA NA NI:
		if b4 = CENTER then
			goto stayCenter
		endif
		if b4 = RIGHT then
			goto stayRight
		endif


		; HLEDA PREKAZKU VLEVO:
		servo SERV,LEFT
		pause SERVO_DELAY
		gosub checkObstackle
		if b2 < 2 then
			b3 = LEFT
		endif
		b4 = NIL
		if b2 = 0 then
			b4 = LEFT
			goto endCheck
		endif


stayCenter:
		; HLEDA PREKAZKU UPROSTRED:
		servo SERV,CENTER
		pause SERVO_DELAY
		gosub checkObstackle
		if b2 < 2 then
			b3 = CENTER
		endif
		if b2 = 0 then
			b4 = CENTER
		endif
		if b2 <> 0 then
			b4 = NIL
			goto endCheck
		endif


stayRight:
		; HLEDA PREKAZKU VPRAVO:
		servo SERV,RIGHT
		pause SERVO_DELAY
		gosub checkObstackle
		if b2 < 2 then
			b3 = RIGHT
		endif
		if b2 = 0 then
			b4 = RIGHT
			goto endCheck
		endif
		if b2 <> 0 then
			b4 = NIL
		endif

		
		; OTOCENI DO STREDOVE POLOHY:
		servo SERV,CENTER
		pause SERVO_DELAY
		b3 = CENTER
	endif
endCheck:

	;gosub checkObstackle		; Vzdalenost se ulozi do  promenne b2
	;gosub decide



	;gosub getRange

	goto mainCycle



; +--------------------------------------------------------+
; | DECIDE                                                 |
; +--------------------------------------------------------+

decide:
	if b2 = 3 then
		gosub goAhead
		goto endTest
	endif

	if b2 = 2 then
		gosub goLeft
		goto endTest
	endif

	if b2 = 1 then
		gosub turnRight
		goto endTest
	endif

	gosub goBack		; Pripad, ze je prekazka nejblize

endTest:
	return



; +--------------------------------------------------------+
; | STOP                                                   |
; +--------------------------------------------------------+
stopMotors:
	; LEVY MOTOR STOP:
	low 4
	low 5
	; PRAVY MOTOR STOP:
	low 6
	low 7
	return



; +--------------------------------------------------------+
; | VPRED                                                  |
; +--------------------------------------------------------+
; | Levy motor : A                                         |
; | Pravy motor: B                                         |
; +--------------------------------------------------------+

goAhead:
	;forward A
	;forward B
	; LEVY MOTOR VPRED:
	low 4
	high 5
	; PRAVY MOTOR VPRED:
	motorRight_ahead:
	high 6
	low 7
	return



; +--------------------------------------------------------+
; | VZAD                                                   |
; +--------------------------------------------------------+
goBack:
	; LEVY MOTOR VZAD:
	high 4
	low 5
	; PRAVY MOTOR VZAD:
	low 6
	high 7
	return



; +--------------------------------------------------------+
; | VLEVO OBLOUKEM                                         |
; +--------------------------------------------------------+
goLeft:
	; LEVY MOTOR STOP:
	low 4
	low 5
	; PRAVY MOTOR VPRED:
	high 6
	low 7
	return



; +--------------------------------------------------------+
; | VPRAVO OBLOUKEM                                        |
; +--------------------------------------------------------+
goRight:
	; LEVY MOTOR VPRED:
	low 4
	high 5
	; PRAVY MOTOR STOP:
	low 6
	low 7
	return



; +--------------------------------------------------------+
; | VLEVO NA MISTE                                         |
; +--------------------------------------------------------+
turnLeft:
	; LEVY MOTOR VZAD:
	high 4
	low 5
	; PRAVY MOTOR VPRED:
	high 6
	low 7
	return



; +--------------------------------------------------------+
; | VPRAVO NA MISTE                                        |
; +--------------------------------------------------------+
turnRight:
	; LEVY MOTOR VPRED:
	low 4
	high 5
	; PRAVY MOTOR VZAD:
	low 6
	high 7
	return



; +--------------------------------------------------------+
; | INFRA DALKOMER                                         |
; +--------------------------------------------------------+
; | Zmeri vzdalenost a vysledek ulozi do promenne b1,      |
; | ktera nespojite nabyva tachto hodnot:                  |
; | 0: vzdalenost mene nez 10 cm                           |
; | 1: vzdalenost v intervalu 10-20 cm                     |
; | 2: vzdalenost b intervalu 20-27 cm                     |
; | 3: vzdalenost vice nez 27 cm                           |
; | Hranice intervalu jsou ponekud "fuzzy", takze se       |
; | nezabyvame jejich otevrenosti ci uzavrenosti           | 
; +--------------------------------------------------------+

checkObstackle:
	readadc 0, b1			; Precte napeti na dalkomeru
                    			; a prevede ho na byte

	if b1 < 64 then		; > 27 cm
		b2 = 3
		low LED_2
		low LED_1
		low LED_0
		goto endCheckObstacke
	endif

	if b1 < 82 then		; 20-27 cm
		b2 = 2
		high LED_2
		low LED_1
		low LED_0
		goto endCheckObstacke
	endif

	if b1 < 128 then		; 10-20 cm 
		b2 = 1
		low LED_2
		high LED_1
		low LED_0
		goto endCheckObstacke
	endif

	if b1 < 128 then		; 0-10 cm 
		b2 = 0
		low LED_0
		low LED_0
		high LED_0
	endif

endCheckObstacke:
	return




