; +--------------------------------------------------------+
; | DEFINICE KONSTANT                                      |
; +--------------------------------------------------------+

; MOTORS:
symbol MOVING_TIME = 1000; 750; 500
symbol TURNING_TIME = 500; 750; 500

; SERVO:
; ( Poloha serva muze byt v rozsahu <75-225> )
symbol TRIM = 10
symbol NIL = 0
symbol LEFT = 90 - TRIM
symbol CENTER = 150 - TRIM
symbol RIGHT = 210 - TRIM
symbol SERVO_DELAY_BEFORE = 450;1000; 500 ;200
symbol SERVO_DELAY_AFTER = 50;1000; 500 ;200

; CHAPADLO:
symbol HAND_OPEN = 160
symbol HAND_HOLD = 100

; POMOCNE NAZVY PRO A/D PREVODNIK:
symbol SERV = 3
symbol LED_0 = 0
symbol LED_1 = 1
symbol LED_2 = 2

; POMOCNE NAZVY PRO VZDALENOSTI:
symbol DISTANCE_10_CM = 128
symbol DISTANCE_20_CM = 82
symbol DISTANCE_30_CM = 64



; +--------------------------------------------------------+
; | VYUZITI A INICIALIZACE PROMENNYCH b0..b13              |                                      |
; +--------------------------------------------------------+

; b0	rezervovano
b1 = 0		; Vzdalenost z infradalkomeru (pomocna promenna)
b2 = 3		; Vzdalenost prekazky (diskretni hodnoty 0, 1, 2, 3)
b3 = CENTER	; Aktulni smer dalkomeru, pripadne smer prekazky (diskretni hodnoty LEFT, CENTER, RIGHT)
b4 = CENTER	; Prioritni smer, pripadne smer nejblizsi prekazky

;w4		; Generovani nahody, w4 = b9 * 256 + b8 !!

b11 = 3	; Vzdalenost nejblizsi prekazky vlevo (diskretni hodnoty 0, 1, 2, 3)
b12 = 3	; Vzdalenost nejblizsi prekazky uprostred (diskretni hodnoty 0, 1, 2, 3)
b13 = 3	; Vzdalenost nejblizsi prekazky vpravo (diskretni hodnoty 0, 1, 2, 3)



; +--------------------------------------------------------+
; | PRIPRAVA VYSTUPNICH PORTU                              |
; +--------------------------------------------------------+
; | Poradi je zde z mnemotechnickych duvodu zprehazeno dle |
; | skutecneho poredi pinu na desce Hobbyrobot-Picaxe      |
; +--------------------------------------------------------+
	low SERV	; 3 (bily) Vystup pulsu na servo
	low LED_0	; 2 (sedy) CLK pro A/D prevodnik
	low LED_1	; 1 (hnedy) STROBE pro A/D prevodnik 
	low LED_2	; 0 (bily) Vystup na signalizacni LED
	low 7  ;  (zeleny) H-mustek pro pravy motor
	low 6	;  (zeleny) H-mustek pro pravy motor
	low 5	; (cerveny) H-mustek pro levy motor 
	low 4	; (cerveny) H-mustek pro levy motor



; +--------------------------------------------------------+
; | HLAVNI SMYCKA PROGRAMU                                 |
; +--------------------------------------------------------+
; | Cil: Pruzkum terenu. Hledat prekazky, ale nenarazet    |
; | do nich                                                |
; | Strategie:                                             |
; | Jede vpred,                                            |
; +--------------------------------------------------------+

mainCycle:

	if b2 > 2 then		; Je vzdalenost prekazky vetsi nez 30 cm ?
 

	; DALKOMER KOUKA DOPREDU:	; ANO -> 
	; ----------------------
		servo SERV,CENTER
		gosub checkObstackle	; Vzdalenost se ulozi do  promenne b2
		b4 = CENTER		; Drz dalkomer v ose 
	endif


	; DALKOMER PROZKOUMAVA OKOLI:
	; --------------------------
	if b2 < 3 then		; NE ->

		if b2 > 0 then
			b4 = NIL
		endif


		; POKUD JE PREKAZKA NEJBLIZE, DALKOMER KOUKA NA NI:
		; ------------------------------------------------
		; ( Prioritni smer je nastaven na smer prekazky )
		if b4 = CENTER then	; Mam drzet dalkomer v ose ?
			goto stayCenter
		endif
		if b4 = RIGHT then
			goto stayRight
		endif


		; HLEDA PREKAZKU VLEVO:
		; --------------------
		servo SERV,LEFT
		gosub checkObstackle	; Vzdalenost se ulozi do  promenne b2
		b11 = b2		; Vzdalenost prekazky ve smeru vlevo
		if b2 < 2 then
			b3 = LEFT	; Aktualni smer
		endif
		b4 = NIL
		if b2 = 0 then
			b4 = LEFT
			goto endCheck	; -> Drz dalkomer vlevo
		endif


stayCenter:
		; HLEDA PREKAZKU UPROSTRED:
		; ------------------------
		servo SERV,CENTER
		;pause SERVO_DELAY
		gosub checkObstackle	; Vzdalenost se ulozi do  promenne b2
		b12 = b2		; Vzdalenost prekazky ve smeru uprostred
		if b2 < 2 then
			b3 = CENTER	; Aktualni smer
		endif
		b4 = NIL
		if b2 = 0 then
			b4 = CENTER
			goto endCheck	; -> Drz dalkomer uprostred
		endif


stayRight:
		; HLEDA PREKAZKU VPRAVO:
		; ---------------------
		servo SERV,RIGHT
		gosub checkObstackle	; Vzdalenost se ulozi do  promenne b2
		b13 = b2		; Vzdalenost prekazky ve smeru vpravo
		if b2 < 2 then
			b3 = RIGHT	; Aktualni smer
		endif

		b4 = NIL
		if b2 = 0 then
			b4 = RIGHT
			goto endCheck	; -> Drz dalkomer vpravo
		endif

		
		; ZPETNE OTOCENI DO STREDOVE POLOHY:
		; ---------------------------------
		servo SERV,CENTER
		;pause SERVO_DELAY_BEFORE
		;pause SERVO_DELAY_AFTER
		b3 = CENTER
	endif
endCheck:

	
	gosub decide

	goto mainCycle



; +--------------------------------------------------------+
; | DECIDE                                                 |
; +--------------------------------------------------------+

decide:
	random w4		; Generovani nahodneho cisla

	; POKUD NENI NIC V CESTE JEDE VPRED, VLEVO, VPRAVO:
	; ------------------------------------------------
	if b12 = 3 then
		gosub goAhead
		goto endTest
	endif

	if b11 = 3 and b13 = 3 and b8 < 128 then
		goto go_left
	endif
		
	if b11 = 3 and b13 = 3 and b8 > 127 then
		goto go_right
	endif
		
	if b11 = 3 and b13 < 3 then
go_left:
		gosub goLeft
		goto endTest
	endif
	if b11 < 3 and b13 = 3 then
go_right:
		gosub goRight
		goto endTest
	endif


	; POKUD JE PREKAZKA VE VZDALENOSTI 20-30 CM, PAK SE ROZHODNE NAHODNE:
	if b12 = 2 then
		gosub goAhead
		goto endTest
	endif

	if b11 = 2 and b13 = 2 and b8 < 128 then
		goto go_left
	endif
	if b11 = 2 and b13 = 2 and b8 > 127 then
		goto go_right
	endif
	
	if b11 = 2 then
		gosub goLeft
		goto endTest
	endif
	if b13 = 2 then
		gosub goRight
		goto endTest
	endif


	; POKUD JE PREKAZKA VE VZDALENOSTI 10-20 CM, PAK SE OTOCI NA "OBRTLIKU" OD NI:
	if b11 = 1 then
		gosub turnRight
		goto endTest
	endif
	;if b12 = 1 then
	;	gosub turnLeft	; udelat Random !
	;	goto endTest
	;endif
	if b13 = 1 then
		gosub turnLeft
		goto endTest
	endif


	; POKUD JE PREKAZKA VE VZDALENOSTI DO 10 CM, COUVA:
	if b12=1 or b11 = 0 or b12 = 0 or b13 = 0 then
		gosub goBack
		goto endTest
	endif


	gosub goBack		; Pripad, ze je prekazka nejblize

endTest:
	return



; +--------------------------------------------------------+
; | STOP                                                   |
; +--------------------------------------------------------+
stopMotors:
	; LEVY MOTOR STOP:
	low 4
	low 5
	; PRAVY MOTOR STOP:
	low 6
	low 7
	return



; +--------------------------------------------------------+
; | VPRED                                                  |
; +--------------------------------------------------------+
; | Levy motor : A                                         |
; | Pravy motor: B                                         |
; +--------------------------------------------------------+

goAhead:
	;forward A
	;forward B
	; LEVY MOTOR VPRED:
	low 4
	high 5
	; PRAVY MOTOR VPRED:
	motorRight_ahead:
	high 6
	low 7
	pause MOVING_TIME
	; OBA MOTORY STOP:
	low 4
	low 5
	low 6
	low 7
	return



; +--------------------------------------------------------+
; | VZAD                                                   |
; +--------------------------------------------------------+
goBack:
	; LEVY MOTOR VZAD:
	high 4
	low 5
	; PRAVY MOTOR VZAD:
	low 6
	high 7
	pause MOVING_TIME
	; OBA MOTORY STOP:
	low 4
	low 5
	low 6
	low 7
	return



; +--------------------------------------------------------+
; | VLEVO OBLOUKEM                                         |
; +--------------------------------------------------------+
goLeft:
	; LEVY MOTOR STOP:
	low 4
	low 5
	; PRAVY MOTOR VPRED:
	high 6
	low 7
	pause MOVING_TIME
	; OBA MOTORY STOP:
	low 4
	low 5
	low 6
	low 7
	return



; +--------------------------------------------------------+
; | VPRAVO OBLOUKEM                                        |
; +--------------------------------------------------------+
goRight:
	; LEVY MOTOR VPRED:
	low 4
	high 5
	; PRAVY MOTOR STOP:
	low 6
	low 7
	pause MOVING_TIME
	; OBA MOTORY STOP:
	low 4
	low 5
	low 6
	low 7
	return



; +--------------------------------------------------------+
; | VLEVO NA MISTE                                         |
; +--------------------------------------------------------+
turnLeft:
	; LEVY MOTOR VZAD:
	high 4
	low 5
	; PRAVY MOTOR VPRED:
	high 6
	low 7
	pause TURNING_TIME
	; OBA MOTORY STOP:
	low 4
	low 5
	low 6
	low 7
	return



; +--------------------------------------------------------+
; | VPRAVO NA MISTE                                        |
; +--------------------------------------------------------+
turnRight:
	; LEVY MOTOR VPRED:
	low 4
	high 5
	; PRAVY MOTOR VZAD:
	low 6
	high 7
	pause TURNING_TIME
	; OBA MOTORY STOP:
	low 4
	low 5
	low 6
	low 7
	return



; +--------------------------------------------------------+
; | INFRA DALKOMER                                         |
; +--------------------------------------------------------+
; | Zmeri vzdalenost a vysledek ulozi do promenne b1,      |
; | ktera nespojite nabyva tachto hodnot:                  |
; | 0: vzdalenost mene nez 10 cm                           |
; | 1: vzdalenost v intervalu 10-20 cm                     |
; | 2: vzdalenost b intervalu 20-27 cm                     |
; | 3: vzdalenost vice nez 27 cm                           |
; | Hranice intervalu jsou ponekud "fuzzy", takze se       |
; | nezabyvame jejich otevrenosti ci uzavrenosti :)        | 
; +--------------------------------------------------------+

checkObstackle:
	pause SERVO_DELAY_BEFORE	; Aby melo servo cas dobehnout do dane polohy

	readadc 0, b1			; Precte napeti na dalkomeru
                    			; a prevede ho na byte

	if b1 < 64 then		; > 27 cm
		b2 = 3
		low LED_2
		low LED_1
		low LED_0
		goto endCheckObstacke
	endif

	if b1 < 82 then		; 20-27 cm
		b2 = 2
		high LED_2
		low LED_1
		low LED_0
		goto endCheckObstacke
	endif

	if b1 < 128 then		; 10-20 cm 
		b2 = 1
		low LED_2
		high LED_1
		low LED_0
		goto endCheckObstacke
	endif

	if b1 > 127 then		; 0-10 cm 
		b2 = 0
		low LED_2
		low LED_1
		high LED_0
	endif

endCheckObstacke:
	pause SERVO_DELAY_AFTER	; Pro jistotu :)
	return





