

; ------------------------------------------
; Definitionen
; ------------------------------------------

; Definition der Ein- und Ausgnge (sog. Ports)
symbol piezo = 2		; Piezo-Lautsprecher am Pin 2 zusammen mit der roten LED

; Variablen
symbol counter = b1	; das Register b1 wird jetzt auch counter genannt



; ------------------------------------------
; Start des Hauptprogramms
; ------------------------------------------

main:
	let pins = %00000110		; Festlegen der Richtung der Ports (0=Eingang; 1=Ausgang)

knot:					; Label loop
	gosub musik			; gehe zur Routine musik
	gosub musikstuecke

	goto knot			; springe zum label loop



; ------------------------------------------
; Routinen
; ------------------------------------------

; Ausgabe von Audio
musik:
	play 0,0					; 0=Happy Birthday, 0=keine extra LED
	pause 500			 		; 500 ms warten
		
	tune 0,4,($80,$84,$87,$D0)		; 0=keine extra LED, 4=Geschwindigkeit
							; Werte in Klammern sind die Tne (hier C-Dur Dreiklang)
	pause 500					; 500 ms warten

	for counter = 120 to 80 step -1 	; von 120 runter bis 80 zaehlen		
		sound piezo,(counter,5) 	; Ausgabe auf den piezo-Lautsprecher,(counter=Tonhhe,5=Tonlnge)	
	next counter				; die Variable counter um eins reduzieren
	pause 500					; 500 ms warten
	return					; zurck zum Programmablauf




; Vorgefertigte Musik ausgeben
musikstuecke:
	; fertige Musik kann mit PICAXE->Wizards->PICAXE-08M Tune eingeladen werden
	; hier A-Team
	tune 0,6,($03,$6A,$C3,$6C,$68,$2A,$23,$6C,$67,$6A,$43,$6A,$45,$C3,$6C,$41,$40,$6A,$68,$EA)

	pause 500					; 500 ms warten
	return


