

; ------------------------------------------
; Definitionen
; ------------------------------------------

; Definition der Ein- und Ausgnge (sog. Ports)
symbol poti = 1		; d.h. das Poti ist an Pin1 angeschlossen		

; Variablen
symbol wert = b2		; Register b2 oder wert
symbol hilf = b3		; Hilfsregister zum Rechnen
symbol spannung = w2	; Register b4 und b5 (sog. Word w2) heissen auch spannung



; ------------------------------------------
; Start des Hauptprogramms
; ------------------------------------------

main:
	let pins = %00010100		; Festlegen der Richtung der Ports (0=Eingang; 1=Ausgang)

knot:					; label loop
	gosub readsensor		; gehe zur Routine readsensor	

	goto knot			; springe zum label loop



; ------------------------------------------
; Routinen
; ------------------------------------------

; Auslesen der Spannung ber dem Potentiometer
; und Ausgabe auf die serielle Schnittstelle
readsensor:
	readadc poti,wert						; lesen des werts am potentiometer; speichern in wert

	let spannung = 176 * wert				; umrechnen des wertes in die spannung
									; 176 ist der Faktor bei 4,5 V (allg. spannung / 255)
	sertxd ("Spannung: ")					; senden von "Spannung " an die serielle Schnittstelle
	let hilf = spannung / 10000				; errechnen der Vorkommastelle
	sertxd (#hilf,",")					; ausgabe der Vorkommastelle und das Komma selbst
	let hilf = hilf * 10000					; errechnen des nachkommateils
	let spannung = spannung - hilf
	sertxd (#spannung," V (= ",#wert,")",13,10)	; ausgabe des nachkommateils, Einheit und 8-bit Messwert (wert)
									; 13 = CR = Enter und 10 = LF = Line Feed

	pause 300							; 300 ms warten bis zur nchsten messung
	return							; zurck zum Programmablauf




