

; ------------------------------------------
; Definitionen
; ------------------------------------------

; Definition der Ein- und Ausgnge (sog. Ports)
symbol sensor = 4		; Sensor an Pin 4

; Variablen
symbol wert = b2		; Register b2 heisst auch wert



; ------------------------------------------
; Start des Hauptprogramms
; ------------------------------------------

main:
	let pins = %00000110		; Festlegen der Richtung der Ports (0=Eingang; 1=Ausgang)

knot:					; Label loop
	gosub temperatur

	goto knot			; springe zum label loop



; ------------------------------------------
; Routinen
; ------------------------------------------

; Auslesen des Temperatursensors und Ausgabe auf die serielle Schnittstelle
temperatur:
	readtemp sensor,wert	 		; einlesen des Werts in das Register wert=b2 (Messbereich: -55 bis 127)
	if wert > 127 then neg 			; wenn der Wert > 127 (d.h. Bit 8 gesetzt) dann ist der Wert negativ
	sertxd ("Temp.: ",#wert,"",13,10) 	; Ausgabe der Temperatur mit Einheit und Zeilenvorschub
							; ASCII-Zeichen 13=CR=Return und 10=LF=Line Feed
	return					; zurck zum Programmablauf
neg:
	let wert = wert - 128 			; berechnen des Wertes wenn negativ
	sertxd ("Temp.: -",#wert,"",13,10)	; Ausgabe von Minuszeichen, Temperatur mit Einheit und Zeilenvorschub
	return					; zurck zum Programmablauf




