; Keyer1b is an iambic Morse keyer
; using PicAxe08m (8 pin) chip.
; modified from Keyer1a, using 08 (smaller memory) chip
; implements autospace function.
; connect dit paddle to ground and leg 4,
; dah paddle to ground and leg 3.
; connect legs 3 and 4 to Vcc though separate 2.2 k resistors.
; leg 5 is output, high = on, suitable for driving transistor base
; for positive logic keying (pull down positive line)
; Speed pot slider connects to leg 6.  Pot ends to Vcc and ground.
; runs fine from 2 AA cells.
; Keyer logic by Gary, ZL1AN
; Coded by Warwick Simpson
; uses 135 of 256 memory bytes
; Gary ZL1AN, 31 October 2004.

symbol ditmemory = b1
symbol dahmemory = b5
symbol ditcontact = pin4	; zero when closed
symbol dahcontact = pin3 ; zero when closed
symbol keyout = 2		 ; high is on
 
input 3		; pin 3 is dah contact
input	4		; pin 4 is dit contact
output keyout	; set pin 2 as output
low keyout		; and set it low (off)

loop:
	if ditcontact = 0 then dit
	if dahcontact = 0 then dah
	goto loop

dit:			; send a dit plus space
	dahmemory = 0
	high keyout		; turn output on

	gosub ditwait	; for a ditspace

	low keyout		; turn output off
	gosub ditwait	; for a ditspace

	if dahmemory = 1 then dah
	goto autospace

dah:			      ; send a dah plus space
	high keyout
	ditmemory = 0

	b0=30
	gosub dahwait

	low keyout

	b0=10
	gosub dahwait

	if ditmemory = 1 then dit	
	goto autospace

checkspeed:		       ; read the speed pot
	readadc 1,b3
	b3=b3/3
	b3=b3+20
	b4=b3/10
	goto loop

ditwait:		       ; send ditspace
	b0=10		       ; checking for dah set
ditwaitloop:  
	pause b4
	if dahcontact = 1 then dontsetb5
	dahmemory = 1	 ; next element is dah
dontsetb5:
	b0=b0-1
	if b0>0 then ditwaitloop
	return

dahwait:		       ; send dahspace
	pause b4	       ; checking for dit set
	if ditcontact = 1 then dontsetb1
	ditmemory = 1	 ;next element is dit
dontsetb1:
	b0=b0-1
	if b0>0 then dahwait
	return

autospace:
      if ditcontact=0 then dit
	if dahcontact=0 then dah
	gosub ditwait
	gosub ditwait
	goto checkspeed
	







